
' We'll utiilize XML to store all the questions
Imports System.Xml

Public Class Database

    ' The DOM-object containing all the XML-info
    Private DomDatabase As Xml.XmlDocument

    ' A list of all the question in this class
    Public Questions As New System.Collections.Generic.List(Of Question)

    ' A list of all of the money values
    Public MoneyGuaranteed As Collection
    Public MoneyList As Collection
    Public MoneyCurrency As String

    ' Description of the different tools
    Public Tools As Tools

    ' Used when creating a new class
    Public Sub New(ByVal DataPath As String)

        ' Initialize the document class
        DomDatabase = New XmlDocument()

        ' Attempt to open the given file
        DomDatabase.Load(DataPath)

        ' Preload all the objects
        LoadQuestions()
        LoadMoney()

        ' Load tools
        Tools = New Tools(DomDatabase.SelectSingleNode("database/tools"))

    End Sub

    Private Sub LoadMoney()

        Dim oMoneyValues As XmlElement, oValue As XmlElement

        ' Load classes
        MoneyGuaranteed = New Collection()
        MoneyList = New Collection()

        ' Load the collection of values
        oMoneyValues = DomDatabase.SelectSingleNode("database/moneylist")

        ' Illiterate through all the elements within, ...
        For Each oValue In oMoneyValues.ChildNodes

            ' ... adding them based upon the name of the element
            Select Case oValue.Name
                Case "value"
                    MoneyList.Add(oValue.InnerText)
                Case "guarenteed"
                    MoneyGuaranteed.Add(oValue.InnerText)
            End Select

        Next

        ' Retrieve the current currency
        MoneyCurrency = oMoneyValues.Attributes("currency").Value

    End Sub

    Private Sub LoadQuestions()

        Dim oQuestions As XmlElement, oQuestion As XmlElement

        ' Retrieve the questions-element
        oQuestions = DomDatabase.SelectSingleNode("database/questions")

        ' Illiterate through all the sub-elements in the questions-element
        For Each oQuestion In oQuestions.ChildNodes

            ' Add each found element to the list, with the wrapper
            Questions.Add(New Question(oQuestion))

        Next

    End Sub

End Class
