Public Class Question

    Private pQuestion As Xml.XmlElement

    ' Here we'll make a wrapper for the given question element
    Public Sub New(ByVal QuestionElement As Xml.XmlElement)

        ' Just reference the element
        pQuestion = QuestionElement

    End Sub

    ' Just the headline of this question
    ReadOnly Property Title() As String
        Get
            ' Return the value, or inner text, of this element
            Return pQuestion("title").InnerText
        End Get
    End Property

    ' Translates to the question text
    ReadOnly Property Description() As String
        Get
            Return pQuestion("description").InnerText
        End Get
    End Property

    ' Returns the level of the question - i.e. on what money level you'd get asked this
    ReadOnly Property Level() As Int32
        Get
            Return pQuestion("level").InnerText
        End Get
    End Property

    ' How many answers do this speficifc question contain
    ReadOnly Property AnswerCount() As Int32
        Get
            Return pQuestion("answers").Attributes("count").Value
        End Get
    End Property

    ' The solution to the question (returns the ID)
    ReadOnly Property AnswersSolution() As String
        Get
            Return pQuestion("answers").Attributes("solution").Value
        End Get
    End Property

    ' The answer itself (zero-based)
    ReadOnly Property AnswersText(ByVal Index As Int32) As String
        Get
            Return pQuestion("answers").GetElementsByTagName("answer").Item(Index).InnerText
        End Get
    End Property

    ' The ID of an answer (zero-based)
    ReadOnly Property AnswersID(ByVal Index As Int32) As String
        Get
            Return pQuestion("answers").GetElementsByTagName("answer").Item(Index).Attributes("id").Value
        End Get
    End Property

    ReadOnly Property Tool(ByVal ToolID As Int32) As Collection
        Get

            Dim oTool As Xml.XmlElement, oAlternative As Xml.XmlElement, tmpCol As New Collection

            ' Go through all tool-elements
            For Each oTool In pQuestion("tools").ChildNodes

                ' See if the ID corresponds
                If Convert.ToInt32(oTool.Attributes("id").Value) = ToolID Then

                    ' Go through all the alternative elements
                    For Each oAlternative In oTool.ChildNodes
                        tmpCol.Add(oAlternative.InnerText)
                    Next

                    ' Return a collection of these
                    Return tmpCol

                End If

            Next

        End Get
    End Property

End Class
