Public Class Tools

    ' An array containing what tools are available
    Public ToolUnavailable() As Boolean
    Public ToolDescription As New Collections.Generic.List(Of String)

    Public Sub New(ByVal ToolsElement As Xml.XmlElement)

        Dim oTool As Xml.XmlElement

        ' Append all tool-descriptions
        For Each oTool In ToolsElement.ChildNodes
            ToolDescription.Add(oTool.InnerText)
        Next

    End Sub

    Public Sub NewGame()

        ' Clear array
        ReDim ToolUnavailable(2)

    End Sub

    Public Function ExecuteTool(ByVal ToolID As Int32, ByVal oQuestion As Question) As String

        Dim oRandom As New Random, colTool As Collection, Tell As Int32

        ' We'll test whether or not the toolID is valid
        Try
            ' Then make sure we haven't already used this tool
            If ToolUnavailable(ToolID) Then
                Return "You've already used this tool."
                Exit Function
            End If
        Catch
            Return "No such tool!"
            Exit Function
        End Try

        ' Execute the different tools
        Select Case ToolID
            Case 0 ' Fifty-fifty

                ' Create a new instance
                colTool = New Collection

                ' Find the incorrect answers
                For Tell = 0 To oQuestion.AnswerCount
                    If oQuestion.AnswersID(Tell) <> oQuestion.AnswersSolution Then
                        colTool.Add(oQuestion.AnswersID(Tell))
                    End If
                Next

                ' Remove till we only have two elements
                Do Until colTool.Count <= 2
                    colTool.Remove(Convert.ToInt32((oRandom.NextDouble * (colTool.Count - 1)) + 1))
                Loop

                ' We've now used this tool
                ToolUnavailable(ToolID) = True

                ' Return the result
                Return "Answer " & colTool(1) & " and " & colTool(2) & " is wrong."

            Case 1, 2 ' "Ask the Audience" and "Ask a friend"

                ' Retrieve an array of texts
                colTool = oQuestion.Tool(ToolID)

                ' We've now used this tool
                ToolUnavailable(ToolID) = True

                ' We'll just show a random message
                Return IIf(ToolID = 1, "", "A friend says: ") & colTool.Item(Convert.ToInt32((oRandom.NextDouble _
                 * (colTool.Count - 1)) + 1))

        End Select

    End Function

End Class
